import "reflect-metadata";
import { API } from "lambda-api";
import { ApiServer } from "./api/ApiServer";
import { Container } from "inversify";
import { AppConfig } from "./model/AppConfig";
export declare abstract class ApiApp {
    protected readonly apiServer: ApiServer;
    protected readonly appContainer: Container;
    constructor(appConfig?: AppConfig, appContainer?: Container);
    /**
     * Configure the IOC container instance.
     */
    configureApp(configureBlock: (appContainer: Container) => void): void;
    /**
     * Configure the lambda-api API instance.
     */
    configureApi(configureBlock: (api: API) => void): void;
    protected initialiseControllers(controllersPath: string): Promise<void>;
}
