"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const marky_1 = require("marky");
const Environment_1 = require("./Environment");
function timed(_, propertyKey, descriptor) {
    const functionToMeasure = descriptor.value;
    descriptor.value = function (...args) {
        if (Environment_1.ProfilingEnabled) {
            marky_1.mark(propertyKey);
        }
        var result = functionToMeasure.apply(this, args);
        if (Environment_1.ProfilingEnabled) {
            var measurement = marky_1.stop(propertyKey);
            console.log(`method '${measurement.name}' took ${measurement.duration.toFixed(2)} ms`);
        }
        return result;
    };
}
exports.timed = timed;
//# sourceMappingURL=timed.js.map